![The PTTH logo, a green box sitting on a black conveyor belt. The box has an arrow pointing left, and the text "PTTH", in white. The conveyor belt has an arrow pointing right, in white.](assets/logo-128-pixel.png)

TODO: "Splitting a server in half" diagram

# PTTH

PTTH is a web server.

A web server has:

1. A public host
2. Files to serve

**With PTTH, the files can live outside of the public host.**

If you want to host 1 TB of files, normally you'd put them on the
cloud server:

```
Cloud
             HTTP server ----> 1 TB of files
                 ^
Not cloud        |
             HTTP client
```

But uploading 1 TB to the cloud is expensive and slow, even if
you're sending it to S3-like blob storage.

With PTTH, the files can live outside of the cloud:

```
Cloud
                 +-----> ptth_relay <------+
                 |                         |
Not cloud        |                         |
             HTTP client               ptth_server
                                      1 TB of files
```

The PTTH server lives where the files live.
The cloud host runs a relay which streams files from the end
server as the client demands.

For home users, this can save you money - The relay server
doesn't need to store any of your files.
